// -*-C++-*-
//
//  This file is part of the Siena Simulator, a simple discrete-event
//  simulator used with the Siena project.  See
//  http://www.cs.colorado.edu/serl/siena/
//
//  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 1998-2000 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: yyfwdtypes.h,v 1.1 2002/09/10 13:48:30 carzanig Exp $
//
#ifndef _YYFWDTYPES_H
#define _YYFWDTYPES_H

#include "yyfwd.h"
#include "siena_types.h"

struct fwdstype {
    const string *		fname;
    unsigned			nlin;
    union {
	int			int_v;
	double			double_v;
	bool			bool_v;
	sx_operator		op;
	sx_message *		message;
	sx_predicate *		predicate;
    };
    sx_value			value;
    sx_constraint		constraint;

    string			str;

    fwdstype(): value(), constraint() {};
};
/*
 *  we can't typedef fwdstype YYSTYPE
 *  we must #define YYSTYPE to prevent bison from #defining it
 */
#define YYSTYPE fwdstype

#define YY_DECL int yylex(YYSTYPE * yylval)
extern YY_DECL;

extern unsigned yyfwdnlin;
extern string yyfwdfname;

#endif
